viTotalState = {};
source(VehicleInspector.modDir.."scripte/mohFeatures/module/viTotalState/viTotalStateConfig.lua");
source(VehicleInspector.modDir.."scripte/mohFeatures/module/viTotalState/viTotalStateOutput.lua");

function viTotalState:update(dt)
	if g_currentMission.multiOverlayV4.moduleFunction.getActiveRunningModul( {modName="vehicleInspector", modulName="viTotalState"} ) then
		if viTotalState.values.updateTimer > 0 then			
			if g_currentMission.hl.timers["viTotalState"] ~= nil then return;end;
			g_currentMission.hl.addTimer( {delay=viTotalState.values.updateTimer, name="viTotalState", repeatable=1, ms=viTotalState.values.msec, action=viTotalState.load} ); 
		else
			viTotalState:load();
		end;
	else
		VehicleInspector.global.isCmdActive.viTotalState = false;
	end;
end;

function viTotalState.loadOnStart(update) --onStartMission Callback, update = updateByPlayer !new object or delete object etc. delete your old cmds!	
	if viTotalState.values == nil then viTotalStateConfig:defaultValues();end;	
	if update == nil then viTotalState:loadAllState(true);end;	
end;

function viTotalState.load()	
	viTotalState:loadAllState();
end;
local test = false;
function viTotalState:loadAllState(generateCmd)	
	local playerFarmId = g_currentMission.player.farmId;	
	local vehicles = {}; 
	if g_currentMission ~= nil and g_currentMission.vehicles ~= nil then
		local totalBuyPrice = 0;
		local totalSellPrice = 0;
		local totalRepairPrice = 0;
		local foundContractorVehicle = false;
		local foundGpsVehicle = false;
		local foundControlledVehicle = false;
		local foundParkingVehicle = false;
		for v=1, #g_currentMission.vehicles do
			local vehicle = g_currentMission.vehicles[v];
			local viewContractorVehicle = vehicle ~= nil and viSetGet:getFarmContractor(playerFarmId, vehicle.ownerFarmId) and not VehicleInspector.seeVehicle.isOwnFarmVehicle;
			if vehicle ~= nil and vehicle.finishedLoading == true and vehicle.spec_rideable == nil and vehicle.trainSystem == nil and (playerFarmId == vehicle.ownerFarmId or viewContractorVehicle) then 
				if vehicle:isa(Vehicle) and not vehicle.isPallet then
					vehicles[#vehicles+1] = {};				
					local vehicleTable = vehicles[#vehicles];
					local storeItem = g_storeManager:getItemByXMLFilename(vehicle.configFileName);
					vehicleTable.node = vehicle.rootNode or vehicle.nodeId;					
					vehicleTable.steeringAxleNode = vehicle.steeringAxleNode;
					vehicleTable.buyPrice = vehicle:getPrice();
					totalBuyPrice = totalBuyPrice+vehicleTable.buyPrice;					
					vehicleTable.sellPrice = vehicle:getSellPrice();
					totalSellPrice = totalSellPrice+vehicleTable.sellPrice;
					vehicleTable.repairPrice = vehicle:getRepairPrice(); --tostring(g_i18n:formatMoney(vehicle:getRepairPrice(), 0, true, false));
					totalRepairPrice = totalRepairPrice+vehicleTable.repairPrice;
					vehicleTable.isLeasing = vehicle.propertyState == 2;
					vehicleTable.leasingCost = 0;
					if vehicleTable.isLeasing then
						local leasingValue = vehicle.price * (EconomyManager.DEFAULT_RUNNING_LEASING_FACTOR + EconomyManager.PER_DAY_LEASING_FACTOR)
						vehicleTable.leasingCost = leasingValue;						 
					end;
					if VehicleInspector.otherMods ~= nil and VehicleInspector.otherMods.gps then
						vehicleTable.hashGps = vehicle.spec_globalPositioningSystem ~= nil and vehicle.spec_globalPositioningSystem.hasGuidanceSystem;						
						vehicleTable.gpsActive = vehicleTable.hashGps and vehicle.spec_globalPositioningSystem.lastInputValues.guidanceIsActive;
						if not foundGpsVehicle and vehicleTable.hashGps then foundGpsVehicle = true;end;
					end;					
					vehicleTable.isParking = viSetGetForMoh:isParkingVehicle(vehicle);
					if not foundParkingVehicle and vehicleTable.isParking then foundParkingVehicle = true;end;
					vehicleTable.age = vehicle.age;					
					vehicleTable.storeName = tostring(vehicle.getName(vehicle));
					vehicleTable.viCategoryName = tostring(vehicle.viCategoryName);
					if vehicleTable.viCategoryName == "unknown" then vehicleTable.viCategoryName = "other";end;					
					vehicleTable.fullName = tostring(vehicle.getFullName(vehicle));
					vehicleTable.typeDescName = tostring(vehicle.typeDesc);
					vehicleTable.typeName = tostring(vehicle.typeName);	
					vehicleTable.farmId = vehicle.ownerFarmId;
					vehicleTable.ownerFarmId = playerFarmId == vehicle.ownerFarmId;
					if not foundContractorVehicle and not vehicleTable.ownerFarmId then foundContractorVehicle = true;end;
					vehicleTable.canControlled = vehicle.getIsControlled ~= nil;				
					if not foundControlledVehicle and vehicleTable.canControlled then foundControlledVehicle = true;end;
					local adErrorHelper = vehicle.getIsAIActive ~= nil and vehicle:getIsAIActive(); --for AD helper Bug Version >2.0.0.5				
					local isHelper = (vehicle.getCurrentHelper ~= nil and vehicle.getCurrentHelper(vehicle)) or adErrorHelper;
					vehicleTable.isControlled = vehicleTable.canControlled and (vehicle.getIsControlled(vehicle) or isHelper);					
					vehicleTable.damage = 0;
					if vehicle.getDamageAmount ~= nil then						
						vehicleTable.damage = 100-g_currentMission.hl.getProzentFillLevel(math.min(1, 1 - vehicle:getDamageAmount()), 1, true);				
					end;
					vehicleTable.mass = vehicle:getTotalMass();	--getDefaultMass()				
					vehicleTable.dailyUpkeep = 0;
					if vehicle.getDailyUpkeep ~= nil and storeItem ~= nil then
						local dailyUpkeep = Vehicle.calculateDailyUpkeep(storeItem, vehicle.age, vehicle.operatingTime, vehicle.configurations);
						--local dailyUpkeep = vehicle:getDailyUpkeep(vehicle);
						if dailyUpkeep ~= nil and dailyUpkeep ~= 0 then
							vehicleTable.dailyUpkeep = dailyUpkeep; --string.format(g_i18n:getText("shop_maintenanceValue"), g_i18n:formatMoney(dailyUpkeep, 2));
						end;
					end;
					if vehicle.getOperatingTime ~= nil then
						vehicleTable.operatingTime = vehicle:getOperatingTime();
						vehicleTable.operatingTimeVI = g_currentMission.hl.getMilliSecondsToHours(vehicleTable.operatingTime, false, true, false, false, false, false);	
						vehicleTable.operatingTimeLS = Vehicle.getSpecValueOperatingTime(nil, vehicle)
					end;
					vehicleTable.maxSpeed = 0;
					vehicleTable.hashEngine = vehicle.spec_motorized ~= nil;					
					vehicleTable.ps = 0;
					vehicleTable.minPs = 0;
					vehicleTable.maxPs = 0;
					vehicleTable.updatePs = 0;
					vehicleTable.canUpdatePs = false;
					if vehicleTable.hashEngine then
						vehicleTable.engineOn = vehicle.spec_motorized.isMotorStarted;
						vehicleTable.temperature = vehicle.spec_motorized.motorTemperature.value
						vehicleTable.maxTemperature = vehicle.spec_motorized.motorTemperature.valueMax;
						vehicleTable.motorType = vehicle.spec_motorized.motorType;
						vehicleTable.maxSpeed = vehicle.spec_motorized.motor.maxForwardSpeed;
						if vehicleTable.maxSpeed ~= math.huge then 
							vehicleTable.maxSpeed = vehicleTable.maxSpeed*3.6;
						else
							vehicleTable.maxSpeed = 0;
						end;						
						function getPower()
							local minPower, maxPower = nil;
							if storeItem ~= nil then
								if storeItem.configurations ~= nil and vehicle.configurations ~= nil and vehicle.configurations.motor ~= nil and storeItem.configurations.motor ~= nil then
									local configId = vehicle.configurations.motor;
									minPower = storeItem.configurations.motor[configId].power;
									maxPower = minPower;
									if minPower == nil then
										minPower = storeItem.specs.power;
										maxPower = minPower;
									end;
									if minPower ~= nil and maxPower ~= nil then
										vehicleTable.minPs = MathUtil.round(minPower);vehicleTable.maxPs = MathUtil.round(maxPower);
									end;
								end;								
								if vehicleTable.minPs == vehicleTable.maxPs then 
									vehicleTable.ps = vehicleTable.maxPs;
									if storeItem.configurations ~= nil and storeItem.configurations.motor ~= nil then
										minPower, maxPower = nil;
										for configId = 1, #storeItem.configurations.motor do
											local configItem = storeItem.configurations.motor[configId];
											if configItem.power ~= nil then
												minPower = math.min(minPower or math.huge, configItem.power);
												maxPower = math.max(maxPower or 0, configItem.power);
											end
										end;
										if minPower == nil then
											minPower = storeItem.specs.power;
											maxPower = minPower;
										end;
										if minPower ~= nil and maxPower ~= nil then
											vehicleTable.minPs = MathUtil.round(minPower);vehicleTable.maxPs = MathUtil.round(maxPower);
											if vehicleTable.ps == 0 then vehicleTable.ps = vehicleTable.minPs;end;
										end;										
									end;
								end;
							end;
						end;
						getPower();
						if vehicleTable.ps == nil then vehicleTable.ps = 0;end;
						if vehicleTable.maxPs == nil or vehicleTable.maxPs == 0 then vehicleTable.maxPs = vehicleTable.ps;end;
						if vehicleTable.minPs == nil or vehicleTable.minPs == 0 then vehicleTable.minPs = vehicleTable.ps;end;
						if vehicleTable.ps < vehicleTable.maxPs and vehicleTable.maxPs ~= vehicleTable.minPs and vehicleTable.minPs > 0 then vehicleTable.canUpdatePs = true;end;
						if vehicleTable.canUpdatePs then vehicleTable.updatePs = vehicleTable.maxPs-vehicleTable.ps;end;
					end;
					vehicleTable.maxWorkingSpeed = 0;
					vehicleTable.loweredWorkingSpeed = false;
					if vehicle.speedLimit ~= nil then
						local speedLimit = vehicle:getRawSpeedLimit();
						if speedLimit ~= math.huge then
							local damage = vehicle:getVehicleDamage();
							if damage > 0 then
								vehicleTable.loweredWorkingSpeed = true;
								--limit = limit * (1 - damage * Vehicle.DAMAGED_SPEEDLIMIT_REDUCTION);
							end;						
							if speedLimit > 5 then
								vehicleTable.maxWorkingSpeed = speedLimit;
							end;
						end;						
					end;
					vehicleTable.fuel = -1;
					vehicleTable.refuel = -1;
					local fuelUnitIndex = 0;
					if vehicleTable.hashEngine or vehicle.getConsumerFillUnitIndex ~= nil then						
						local fuelLevel, capacity, fillUnitIndex = viSetGet:getVehicleFuelLevelAndCapacity(vehicle);
						vehicleTable.fuel = fuelLevel or 0;
						vehicleTable.fuelCapacity = capacity or 0;
						local fuelIndex = vehicle:getFillUnitByIndex(fillUnitIndex);
						vehicleTable.refuel = vehicleTable.fuelCapacity-vehicleTable.fuel;
						if fuelIndex ~= nil then
							vehicleTable.fuelName = tostring(g_currentMission.fillTypeManager:getFillTypeNameByIndex(fuelIndex.fillType));							
						end;
					end;
					vehicleTable.capacity = 0;					
					if vehicle.spec_fillUnit ~= nil then
						local spec = vehicle.spec_fillUnit;							
						for index, fillUnit in ipairs(spec.fillUnits) do
							if fillUnit.supportedFillTypes ~= nil and fillUnit.showOnInfoHud then			
								for fillType,isAccepted in pairs(fillUnit.supportedFillTypes) do
									if isAccepted and fillType ~= nil and fillType ~= FillType.DEF and fillType ~= FillType.AIR and fillType ~= FillType.UNKNOWN and fillType ~= FillType.TARP and fillType ~= FillType.DIESEL and fillType ~= FillType.ELECTRICCHARGE and fillType ~= FillType.METHANE then
										vehicleTable.capacity = Utils.getNoNil(fillUnit.capacity,0);
										break;
									end;					
								end;			
							end;		
						end;										
					end;
					vehicle.viFillCapacity = vehicleTable.capacity;	--for preview Vehicle Icon				
					vehicleTable.isWeight = vehicleTable.typeName == "implement" or vehicleTable.typeName == "implements";
					--vehicleTable.isPowered = vehicle:getIsPowered(); 
					--vehicleTable.requiresPower = vehicle:getRequiresPower();					
				end;
			end;
		end;
		if test then
			test = false;
			print(DebugUtil.printTableRecursively(vehicles, "vehicles ", 0, 2))			
		end;
		function comp(w1,w2)			
			if w1[viTotalState.values.sortBy.what] ~= nil and w2[viTotalState.values.sortBy.what] ~= nil then
				if viTotalState.values.sortBy.typ == "low" then				
					if w1[viTotalState.values.sortBy.what] < w2[viTotalState.values.sortBy.what] then
						return true;
					end;
				elseif viTotalState.values.sortBy.typ == "high" then
					if w1[viTotalState.values.sortBy.what] > w2[viTotalState.values.sortBy.what] then
						return true;
					end;					
				elseif viTotalState.values.sortBy.typ == "bol" then
					return w1[viTotalState.values.sortBy.what] and not w2[viTotalState.values.sortBy.what];
				end;
			end;
		end;		
		table.sort(vehicles, comp);
		if #vehicles > 0 then
			table.insert(vehicles, 1, {});
			vehicles[1].totalBuyPrice = tostring(g_i18n:formatMoney(totalBuyPrice, 0, true, false));vehicles[1].totalSellPrice = tostring(g_i18n:formatMoney(totalSellPrice, 0, true, false));vehicles[1].totalRepairPrice = tostring(g_i18n:formatMoney(totalRepairPrice, 0, true, false));
			vehicles[1].foundContractorVehicle=foundContractorVehicle;vehicles[1].foundControlledVehicle=foundControlledVehicle;vehicles[1].foundGpsVehicle=foundGpsVehicle;vehicles[1].foundParkingVehicle=foundParkingVehicle;
		end;
		viTotalState.values.vehicles = vehicles; --new		
	end;
	if generateCmd ~= nil and generateCmd then viTotalStateConfig:generateCmd();end;
end;
if g_currentMission.multiOverlayV4 ~= nil then
	g_currentMission.multiOverlayV4.moduleFunction.addCallbackModul( { modName="vehicleInspector", modulCallbackName="onStartMission", callback=viTotalState.loadOnStart } );
	g_currentMission.multiOverlayV4.moduleFunction.addCallbackModul( { modName="vehicleInspector", modulCallbackName="update", callback=viTotalState.update } );
end;