viTotalStateConfig = {};

function viTotalStateConfig:defaultValues()
	viTotalState.values = {notScrollLines=4, updateTimer=30, msec=false, vehicles={}, selectVehicle=0, sortBy={typ="low",what="fullName",accepts={}}};
	viTotalState.values.sortBy.accepts = {typeDescName=true,fullName=true,viCategoryName=true,canControlled=true,hashGps=true,isParking=true,sellPrice=true,buyPrice=true,repairPrice=true,leasingCost=true,age=true,fuel=true,operatingTime=true,ownerFarmId=true,maxSpeed=true,ps=true,mass=true};
	viTotalState.values.view = {all=false,age=true,sellPrice=true,buyPrice=false,repairPrice=true,fuel=true,leasingCost=false,operatingTime=true,maxSpeed=false,ps=false,mass=false};
	viTotalState.values.viewOther = {maxWorkingSpeed=false,refuel=true,updatePs=false};
	viTotalState.values.viewTyp = {isWeight=true,canControlled=true};
end;

function viTotalStateConfig.loadXml(Xml, xmlNameTag, directory, typ) --loadConfig Callback	
	if typ ~= "profilSettings" then return;end;	
	if viTotalState.values == nil then viTotalStateConfig:defaultValues();end;
	local groupNameTag = (xmlNameTag.. ".module.viTotalState(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.. "#mSecTimer") ~= nil then
		viTotalState.values.msec = getXMLBool(Xml, groupNameTag.. "#mSecTimer");
	else
		return; --first config not found
	end;
	if getXMLInt(Xml, groupNameTag.. "#updateTimer") ~= nil then
		viTotalState.values.updateTimer = getXMLInt(Xml, groupNameTag.. "#updateTimer");
	end;
	if getXMLString(Xml, groupNameTag.. "#sortByTyp") ~= nil then
		viTotalState.values.sortBy.typ = getXMLString(Xml, groupNameTag.. "#sortByTyp");
		if viTotalState.values.sortBy.typ ~= "high" and viTotalState.values.sortBy.typ ~= "low" and viTotalState.values.sortBy.typ ~= "bol" then viTotalState.values.sortBy.typ = "low";end;
	end;
	if getXMLString(Xml, groupNameTag.. "#sortByWhat") ~= nil then
		viTotalState.values.sortBy.what = getXMLString(Xml, groupNameTag.. "#sortByWhat");		
		if viTotalState.values.sortBy.accepts[viTotalState.values.sortBy.what] == nil then viTotalState.values.sortBy.what = "fullName";viTotalState.values.sortBy.typ = "low";end;		
	end;
	if viTotalState.values.sortBy.what ~= "fullName" then viTotalState:loadAllState();end; --sortBy change
end;

function viTotalStateConfig.saveXml(Xml, xmlNameTag, directory, typ) --saveConfig Callback
	if typ ~= "profilSettings" then return;end;	
	if viTotalState.values == nil then viTotalState:defaultValues();end;
	----------------------------------------------------------------------------------------------
	local groupNameTag = (xmlNameTag.. ".module.viTotalState(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#updateTimer", viTotalState.values.updateTimer);
	setXMLBool(Xml, groupNameTag.. "#mSecTimer", viTotalState.values.msec);
	setXMLString(Xml, groupNameTag.. "#sortByTyp", viTotalState.values.sortBy.typ);
	setXMLString(Xml, groupNameTag.. "#sortByWhat", viTotalState.values.sortBy.what);
	----------------------------------------------------------------------------------------------	
end;

function viTotalStateConfig:generateCmd()
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "output_viTotalState_";
			groupName = "VehicleInspector";			
			displayName = g_i18n:getText("ui_garageOverview").. " (".. 	g_i18n:getText("ui_statistics").. ")";
			infoTxt = "Click Left/Right/Middle for Interaction. Set Slot Big Width/Height and only CMD in Slot";
			mouseClickAccepts = {true,true,true};
			ownTable = {};
			typ = {"output_"};			
			actionCallback = viTotalStateOutput.giveOutputTable;
			delCmdCallback = viTotalStateOutput.checkNotScroll;
		}
	);
	g_currentMission.multiOverlayV4.cmdFunction.generateCmd( { 
			modName = "VehicleInspector";
			cmdName = "output_viTotalStateDummy_";
			groupName = "VehicleInspector";			
			displayName = "Scroll Fix for Cmd --> ".. g_i18n:getText("ui_garageOverview").. " (".. 	g_i18n:getText("ui_statistics").. ") *View Info Txt*";
			infoTxt = "Dummy Fix Lines. Set this Cmd last in Slot. Fix view/Scroll next CMD";
			mouseClickAccepts = {false,false,false};
			ownTable = {};
			typ = {"output_"};			
			actionCallback = viTotalStateOutput.giveOutputTableFixLines;			
		}
	);
end;
if g_currentMission.multiOverlayV4 ~= nil then
	g_currentMission.multiOverlayV4.moduleFunction.addCallbackModul( {modName="vehicleInspector", modulCallbackName="loadConfig", callback=viTotalStateConfig.loadXml } );
	g_currentMission.multiOverlayV4.moduleFunction.addCallbackModul( {modName="vehicleInspector", modulCallbackName="saveConfig", callback=viTotalStateConfig.saveXml } );
end;
